// Neocola

// Dependencies -------------------------------------------------------------->

var express = require('express');
var engine  = require('ejs-locals');
var everyauth = require('everyauth');
var flash = require('connect-flash');
var http = require('http');
var path = require('path');
var routes = require('./router');

// Other Declarations
var app = module.exports = express();
store  = new express.session.MemoryStore;

// Set up Sequelize
var db = require('data');

// Set up Passport for authentication
require('./config/everyauth')(__dirname, db, everyauth);


// Configuration -------------------------------------------------------------->

// All Environments
app.set('port', process.env.PORT || 9080);
app.engine('ejs', engine);
app.set('view engine', 'ejs');
app.use(express.logger('dev'));
app.use(express.methodOverride());
app.use(express.cookieParser('fs9HDaatx82GEhsupzcda5DDANp'));
app.use(express.bodyParser());
app.use(express.session({
    secret: 'peach1a',
    store: store,
    key: 'sid',
    cookie: {maxAge: 1000*60*60}
}));
app.use(flash());
app.use(express.static(path.join(__dirname, 'public')));
app.use(everyauth.middleware(app));
app.use(app.router);
app.enable('trust proxy');

// Development Settings
app.configure('development', function() {
    console.log('Using development settings.');
    app.use(express.errorHandler());
});

// Production Settings
app.configure('production', function() {
    console.log('Using production settings.');
});

// Set up Routes
routes.route(app, db);


// Sync Models & Database
db.sequelize.sync().complete(function(err) {
    if (err) {
        throw err
    } else {
        console.log('Database synchronization complete.');

        app.listen(app.get('port'), function(){
            console.log('Neocola is listening on port ' + app.get('port'));
        });
    }
});